<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\CustomerData;

use FiloBlu\ExtAmastyGeoipRedirect\Helper\Data;
use Magento\Customer\CustomerData\SectionSourceInterface;
use Magento\Framework\Exception\InputException;
use Magento\Framework\Exception\NoSuchEntityException;
use Magento\Framework\Stdlib\Cookie\CookieSizeLimitReachedException;
use Magento\Framework\Stdlib\Cookie\FailureToSendException;
use Magento\Store\Model\StoreManagerInterface;

/**
 * Class GeoipData
 * @package FiloBlu\ExtAmastyGeoipRedirect\CustomerData
 */
class GeoipData implements SectionSourceInterface
{
    /**
     * @var Data
     */
    protected $helper;

    /**
     * @var StoreManagerInterface
     */
    protected $storeManager;

    /**
     * GeoipData constructor.
     * @param Data $helper
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(
        Data $helper,
        StoreManagerInterface $storeManager
    ) {
        $this->helper = $helper;
        $this->storeManager = $storeManager;
    }

    /**
     * @return array
     * @throws InputException
     * @throws NoSuchEntityException
     * @throws CookieSizeLimitReachedException
     * @throws FailureToSendException
     */
    public function getSectionData()
    {
        $store = $this->storeManager->getStore();
        return [
            'current_country_code' => $this->helper->getCurrentCountryCode(),
            'current_country_name' => $this->helper->getCurrentCountryName(),
            'current_store_url' => $store->getBaseUrl(),
            'current_store_id' => $store->getId(),
        ];
    }
}
